#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/04/30
#Last Modify: 2018/04/30
# deeper learning insights machine learning page 593

import matplotlib.pyplot as plt
from sklearn.datasets import fetch_olivetti_faces
from sklearn.ensemble import ExtraTreesClassifier
data = fetch_olivetti_faces() #NOTE need to download data, not online...

def importance(n_estimators=500, max_features=128, n_jobs=3, random_state=0):
  X = data.images.reshape((len(data.images), -1))
  y = data.target
  forest = ExtraTreesClassifier(n_estimators,
                                max_features=max_features,
                                n_jobs=n_jobs,
                                random_state=random_state)
  forest.fit(X, y)
  dstring = " cores=%d..."%n_jobs + " features=%s..."%max_features
  +"estimators=%d..."%n_estimators + "random=%d" %random_state
  print(dstring)
  importances = forest.feature_importances_
  importances = importances.reshape(data.images[0].shape)
  plt.matshow(importances, cmap=plt.cm.hot)
  plt.title(dstring)
  #plt.savefig('etreesImportance'+ dstring + '.png')
  plt.show()
importance()
